Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# TQWidgetStack Class Reference

The TQWidgetStack class provides a stack of widgets of which only the top widget is user-visible. More...

`#include <ntqwidgetstack.h>`

Inherits TQFrame.

List of all member functions.

## Public Members

- TQWidgetStack ( TQWidget * parent = 0, const char * name = 0 )
- TQWidgetStack ( TQWidget * parent, const char * name, WFlags f )
- ~TQWidgetStack ()
- int addWidget ( TQWidget * w, int id = -1 )
- void removeWidget ( TQWidget * w )
- TQWidget * widget ( int id ) const
- int id ( TQWidget * widget ) const
- TQWidget * visibleWidget () const

## Public Slots

- void raiseWidget ( int id )
- void raiseWidget ( TQWidget * w )

## Signals

- void aboutToShow ( int )
- void aboutToShow ( TQWidget * )

## Protected Members

- virtual void setChildGeometries ()

## Detailed Description

The TQWidgetStack class provides a stack of widgets of which only the top widget is user-visible.

The application programmer can move any widget to the top of the stack at any time using raiseWidget(), and add or remove widgets using addWidget() and removeWidget(). It is not sufficient to pass the widget stack as parent to a widget which should be inserted into the widgetstack.

visibleWidget() is the get equivalent of raiseWidget(); it returns a pointer to the widget that is currently at the top of the stack.

TQWidgetStack also provides the ability to manipulate widgets through application-specified integer IDs. You can also translate from widget pointers to IDs using id() and from IDs to widget pointers using widget(). These numeric IDs are unique (per TQWidgetStack, not globally), but TQWidgetStack does not attach any additional meaning to them.

The default widget stack is frameless, but you can use the usual TQFrame functions (such as setFrameStyle()) to add a frame.

TQWidgetStack provides a signal, aboutToShow(), which is emitted just before a managed widget is shown.

See also TQTabDialog, TQTabBar, TQFrame, and Organizers.

## Member Function Documentation

### TQWidgetStack::TQWidgetStack ( TQWidget * parent = 0, const char * name = 0 )

Constructs an empty widget stack.

The parent and name arguments are passed to the TQFrame constructor.

### TQWidgetStack::TQWidgetStack ( TQWidget * parent, const char * name, WFlags f )

Constructs an empty widget stack.

The parent, name and f arguments are passed to the TQFrame constructor.

### TQWidgetStack::~TQWidgetStack ()

Destroys the object and frees any allocated resources.

### void TQWidgetStack::aboutToShow ( int )`[signal]`

This signal is emitted just before a managed widget is shown if that managed widget has an ID != -1. The argument is the numeric ID of the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget it returns is the one that is currently visible, not the one that is about to be shown.

### void TQWidgetStack::aboutToShow ( TQWidget * )`[signal]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

This signal is emitted just before a managed widget is shown. The argument is a pointer to the widget.

If you call visibleWidget() in a slot connected to aboutToShow(), the widget returned is the one that is currently visible, not the one that is about to be shown.

### int TQWidgetStack::addWidget ( TQWidget * w, int id = -1 )

Adds widget w to this stack of widgets, with ID id.

If you pass an id >= 0 this ID is used. If you pass an id of -1 (the default), the widgets will be numbered automatically. If you pass -2 a unique negative integer will be generated. No widget has an ID of -1. Returns the ID or -1 on failure (e.g. w is 0).

If you pass an id that is already used, then a unique negative integer will be generated to prevent two widgets having the same id.

If w already exists in the stack the widget will be removed first.

If w is not a child of this TQWidgetStack moves it using reparent().

Example: xform/xform.cpp.

### int TQWidgetStack::id ( TQWidget * widget ) const

Returns the ID of the widget. Returns -1 if widget is 0 or is not being managed by this widget stack.

See also widget() and addWidget().

### void TQWidgetStack::raiseWidget ( int id )`[slot]`

Raises the widget with ID id to the top of the widget stack.

See also visibleWidget().

Example: xform/xform.cpp.

### void TQWidgetStack::raiseWidget ( TQWidget * w )`[slot]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

Raises widget w to the top of the widget stack.

### void TQWidgetStack::removeWidget ( TQWidget * w )

Removes widget w from this stack of widgets. Does not delete w. If w is the currently visible widget, no other widget is substituted.

See also visibleWidget() and raiseWidget().

### void TQWidgetStack::setChildGeometries ()`[virtual protected]`

Fixes up the children's geometries.

### TQWidget * TQWidgetStack::visibleWidget () const

Returns the currently visible widget (the one at the top of the stack), or 0 if nothing is currently being shown.

See also aboutToShow(), id(), and raiseWidget().

### TQWidget * TQWidgetStack::widget ( int id ) const

Returns the widget with ID id. Returns 0 if this widget stack does not manage a widget with ID id.

See also id() and addWidget().

This file is part of the TQt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.